/*
     get source data
*/

#include <ctype.h>
#include "rt.h"
#include <string.h>

/* data format

rmode pixw pixh sx sy ex ey dx dy asp
maxtn mintv esp anti anti_level
ep.x ep.y ep.z
re.x re.y re.z
sre.x sre.y sre.z
edeg ew
half mist
sky.r sky.g sky.b
env.r snv.g env.b
output_filename



[
elt.x elt.y elt.z
elc.r elc.g elc.b
els elk
   .
   .
   .
   .
]



[
plt.x plt.y plt.z
plc.r plc.g plc.b
plk
   .
   .
   .
   .
]



[
slt.x slt.y slt.z
sld.x sld.y sld.z
slc.r slc.g slc.b
sls slk
   .
   .
   .
   .
]



[
filename
   .
   .
   .
   .
]



[
pc.r pc.g pc.b        < (trans) map0 .... >
:
: trans->        :rx :ry :rz
:                :mx :my :mz
:                :sx :sy :sz
:                              ݉
:
: map->   map_num map_k map_mode (mappara)
:       (mappara) map_mode = 0 (S}bsO): u1
:                            1 (ʃ}bsO)  : u1,v1,u2,v2,u1a,v1a,u2a,v2a
:                            2 (ʃ}bsO)  : u1,v1,u2,v2,u1a,v1a,u2a,v2a
:                                           -1 <= u <= 1 , -1 <= v <= 1
:                            3 (}bsO)  : u1,v1,u2,v2,u1a,v1a,u2a,v2a
:                                           -1 <= u <= 1 , 0 <= v 
:                            4 (~}bsO)  : u1,v1,u2,v2,u1a,v1a,u2a,v2a
:                                           -1 <= u <= 1
:
refl.r refl.g refl.b  < (trans) map0 .... >
refr.r refr.g refr.b  < (trans) map0 .... >
n                     < (trans) map0 .... >
half                  < (trans) map0 .... >
bump                  < (trans) map0 .... >
styp spara

:               (spara) styp = 0 : (blinn1) 
:                                  high     < (trans) map0 .... >
:                                  k        < (trans) map0 .... >
:
:               (spara) styp = 1 : (blinn2)
:                                  ref.r ref.g ref.b  < (trans) map0 .... >
:                                  n        < (trans) map0 .... >
:                                  f        < (trans) map0 .... >
:
:               (spara) styp = 2 : (brush circle)
:                                  ref.r ref.g ref.b  < (trans) map0 .... >
:                                  px py pz
:                                  vx vy vz
:                                  a        < (trans) map0 .... >
:                                  b        < (trans) map0 .... >
:                                  c        < (trans) map0 .... >
:
:               (spara) styp = 3 : (brush line)
:                                  ref.r ref.g ref.b  < (trans) map0 .... >
:                                  vx vy vz
:                                  a        < (trans) map0 .... >
:                                  b        < (trans) map0 .... >
:                                  c        < (trans) map0 .... >
:
:   .
   .
   .
   .
]



[
  Primitives
      or
  Or levels    [...]
      or
  And levels   {...}
      or
  Range levels (
                ptyp  l m n  
                  @@@@@@ptyp = 0 : a0---a9
@@@@                  @@       1 : a b c
@@@@                  @@       2 : r
@@@@@@                         3 : p q r
@@@@@@                         4 : a b c r/t
@@@@                  @@       5 : a b c r
@@@@                  @@       6 : a b c q r
                ...
               )


:===Primitive format===
:
:sgn
:(trans for color_n) color_num     < (trans for map) map >
:ptyp
:l m n
:
:@@@@@@ptyp = 0 : a0---a9
:@@@@@@       1 : a b c
:@@@@@@       2 : r
:@@@@@@       3 : p q r
:@@@@@@       4 : a b c r/t
:@@@@@@       5 : a b c r
:@@@@@@       6 : a b c q r
:

]

*/


void getsrc( char *fn )
{
FILE *fp ;
char filename[32],msg[256] ;
int i,ch ;
float x,y,z ;
FV *vp ;
FRGB *cp ;
SPECK1 *speck1 ;
SPECK2 *speck2 ;
SPECK3 *speck3 ;
SPECK4 *speck4 ;
MATRIX mtx_tmp1,mtx_tmp2 ;






  if(( fp = fopen( fn, "r" ) ) == NULL ) 
    err( "(getsrc) t@C܂" ) ;
  fscanf( fp, "%d%d%d%d%d%d%d%d%d%lf",
            &rmode,&PIXW,&PIXH,&sx,&sy,&ex,&ey,&dx,&dy,&asp ) ;
  if( sx<0 || sy<0 || sx>PIXW-1 || sy>PIXH-1 || 
      ex<0 || ey<0 || ex>PIXW-1 || ey>PIXH-1)
    err( "(getsrc) vZʂُ͈̔͂ł" );
  xasp=((float)(DSP_PIXW)) / (float)PIXW;
  yasp=((float)(DSP_PIXH)) / (float)PIXH * asp;
  if( xasp < 1.0 || yasp < 1.0 )
  {
    if( xasp < yasp )
    {
      yasp = xasp / asp;
    }
    else
    {
      yasp = yasp / asp;
      xasp = yasp * asp;
    }
  }
  else
  {
    xasp = 1.0;
    yasp = 1.0 / asp;
  }
  fscanf( fp, "%d%lf%lf%d%lf", &maxtn,&mintv,&eps,&anti,&anti_level ) ;
  fscanf( fp, "%lf%lf%lf", &ep.x, &ep.y, &ep.z ) ;
  fscanf( fp, "%lf%lf%lf", &re.x, &re.y, &re.z ) ;
  fscanf( fp, "%lf%lf%lf", &sre.x, &sre.y, &sre.z ) ;
  fscanf( fp, "%lf%lf", &edeg, &ew ) ;
  sre.x -= re.x; sre.y -= re.y ; sre.z -= re.z ;
  x = ev.x = re.x - ep.x ; y= ev.y = re.y - ep.y ; z= ev.z = re.z - ep.z ;
  du = sqrt((ev.x)*(ev.x) + (ev.y)*(ev.y) + (ev.z)*(ev.z))*tan(edeg * DEG) ;
  dv = du * PIXH / PIXW / asp ;
  du /= PIXW/2. ; dv /= PIXH/2. ;
  u.x = sre.z*y-sre.y*z ; u.y = sre.x*z-sre.z*x ; u.z=sre.y*x-sre.x*y ;
  temp=sqrt((u.x)*(u.x) + (u.y)*(u.y) + (u.z)*(u.z)) ;
  u.x /= temp;u.y /=temp; u.z /= temp ;
  
/*  temp = -(sre.x*x+sre.y*y+sre.z*z)/sqrt((sre.x)*(sre.x) + (sre.y)*(sre.y)+ (sre.z)*(sre.z)) /(x*x+y*y+z*z) ;
  v.x = sre.x + temp*x ; v.y = sre.y+temp*y ; v.z = sre.z+temp*z ;*/
  v.x = z*u.y-y*u.z ; v.y = x*u.z-z*u.x ; v.z = y*u.x-x*u.y ;
  temp=sqrt((v.x)*(v.x) + (v.y)*(v.y) + (v.z)*(v.z)) ;
  v.x /= temp;v.y /=temp; v.z /= temp ;
  temp=sqrt((ev.x)*(ev.x) + (ev.y)*(ev.y) + (ev.z)*(ev.z)) ;
  ev.x /= temp;ev.y /=temp; ev.z /= temp ;
  
  if( rmode & 1 ) { /* left & right eye point */
    temp = temp * ew / 2 ; /* 1/2 eye width */
    lep.x = ep.x-u.x*temp; lep.y = ep.y-u.y*temp ; lep.z = ep.z-u.z*temp;
    rep.x = ep.x+u.x*temp; rep.y = ep.y+u.y*temp ; rep.z = ep.z+u.z*temp;
  }
#ifdef DEBUG
fprintf(stderr,"u=(%lf,%lf,%f),v=(%f,%f,%f),du=%f,dv=%f\n",
                              u.x,u.y,u.z,v.x,v.y,v.z,du,dv ) ;
#endif
  
  fscanf( fp, "%lf%d", &half,&mist ) ;
  fscanf( fp, "%lf%lf%lf", &sky.r, &sky.g, &sky.b ) ;
  fscanf( fp, "%lf%lf%lf", &env.r, &env.g, &env.b ) ;
  fscanf( fp, "%s", output_filename );
  
  
  if ( (ch=skip(fp)) == -1 )
    err("(getsrc) ̓ǂݍݒEOFɂȂ܂");
  if ( ch!='[' ) 
    err("(getsrc) ̃f[^ [ Ŏn܂Ă܂");
  el = malloc(0) ;
  i = 0 ;
  while( 1 ) {
    if ( (ch=skip(fp)) == -1 )
      err("(getsrc) ̓ǂݍݒEOFɂȂ܂");
    if ( ch==']' ) break;
    ungetc(ch,fp);
    
    el = realloc(el,sizeof(ELIT)*(i+1));
    vp = &(el[i].elt) ;
    fscanf( fp, "%lf%lf%lf", &(vp->x),&(vp->y),&(vp->z) ) ;
    temp=sqrt(((*vp).x)*((*vp).x) + ((*vp).y)*((*vp).y)
         +((*vp).z)*((*vp).z)) ;
    (*vp).x /= temp;(*vp).y /=temp; (*vp).z /= temp ;
    cp = &(el[i].elc) ;
    fscanf( fp, "%lf%lf%lf", &(cp->r),&(cp->g),&(cp->b) ) ;
    fscanf( fp, "%lf%lf", &temp, &(el[i].elk) ) ;
    el[i].els = cos( temp * DEG ) ;
    
    i++;
  }
  elnum = i;
  sprintf(msg,"%ld ̖ݒ肳܂B",elnum);
  mes(msg);
#ifdef DEBUG
fprintf( stderr, "Number of eternal light:%d\n",elnum ) ;
#endif
  
  
  if ( (ch=skip(fp)) == -1 )
    err("(getsrc) _̓ǂݍݒEOFɂȂ܂");
  if ( ch!='[' )
    err("(getsrc) _̃f[^ [ Ŏn܂Ă܂");
  pl = malloc(0) ;
  i = 0 ;
  while( 1 ) {
    if ( (ch=skip(fp)) == -1 )
      err("(getsrc) _̓ǂݍݒEOFɂȂ܂");
    if ( ch==']' ) break;
    ungetc(ch,fp);
    
    pl = realloc(pl,sizeof(PLIT)*(i+1));
    vp = &(pl[i].plt) ;
    fscanf( fp, "%lf%lf%lf", &(vp->x),&(vp->y),&(vp->z) ) ;
    cp = &(pl[i].plc) ;
    fscanf( fp, "%lf%lf%lf", &(cp->r),&(cp->g),&(cp->b) ) ;
    fscanf( fp, "%lf", &(pl[i].plk) ) ;
    
    i++;
  }
  plnum = i;
  sprintf(msg,"%ld ̓_ݒ肳܂B",plnum);
  mes(msg);
#ifdef DEBUG
fprintf( stderr, "Number of point light:%d\n",plnum ) ;
#endif
  
  
  if ( (ch=skip(fp)) == -1 )
    err("(getsrc) X|bgCg̓ǂݍݒEOFɂȂ܂");
  if ( ch!='[' ) 
    err("(getsrc) X|bgCg̃f[^ [ Ŏn܂Ă܂");
  sl = malloc(0) ;
  i = 0 ;
  while( 1 ) {
    if ( (ch=skip(fp)) == -1 )
      err("(getsrc) X|bgCg̓ǂݍݒEOFɂȂ܂");
    if ( ch==']' ) break;
    ungetc(ch,fp);
    
    sl = realloc(sl,sizeof(SLIT)*(i+1));
    vp = &(sl[i].slt) ;
    fscanf( fp, "%lf%lf%lf", &(vp->x),&(vp->y),&(vp->z) ) ;
    vp = &(sl[i].sld) ;
    fscanf( fp, "%lf%lf%lf", &(vp->x),&(vp->y),&(vp->z) ) ;
    vp->x -= (sl[i].slt).x;
    vp->y -= (sl[i].slt).y;
    vp->z -= (sl[i].slt).z;
    temp = sqrt( sq(vp->x) + sq(vp->y) + sq(vp->z) );
    vp->x /= temp;
    vp->y /= temp;
    vp->z /= temp;
    
    cp = &(sl[i].slc) ;
    fscanf( fp, "%lf%lf%lf", &(cp->r),&(cp->g),&(cp->b) ) ;
    fscanf( fp, "%lf%lf", &(sl[i].sls) , &(sl[i].slk) ) ;
    
    i++;
  }
  slnum = i;
  sprintf(msg,"%ld ̃X|bgCgݒ肳܂B",slnum);
  mes(msg);
#ifdef DEBUG
fprintf( stderr, "Number of spot light:%d\n",slnum ) ;
#endif
  
  
  if ( (ch=skip(fp)) == -1 )
    err("(getsrc) }bsOf[^̓ǂݍݒEOFɂȂ܂");
  if ( ch!='[' )
    err("(getsrc) }bsOf[^̃f[^ [ Ŏn܂Ă܂");
  maptyp = malloc(0);
  gx = malloc(0);
  gy = malloc(0);
  map = malloc(0);
  i = 0 ;
  while( 1 ) {
    if ( (ch=skip(fp)) == -1 ) {
      err("(getsrc) }bsOf[^̓ǂݍݒEOFɂȂ܂");
    }
    if ( ch==']' ) break;
    ungetc(ch,fp);
    
    maptyp = realloc(maptyp,sizeof(int)*(i+1));
    gx = realloc(gx,sizeof(int)*(i+1));
    gy = realloc(gy,sizeof(int)*(i+1));
    map = realloc(map,sizeof(map)*(i+1));
    fscanf( fp, "%s", filename);
    loadmap(i,filename);
    
    i++;
  }
  mapnum = i;
  sprintf(msg,"%ld ̃}bsOf[^ݒ肳܂B",mapnum);
  mes(msg);
  
  
  
  if ( (ch=skip(fp)) == -1 )
    err("(getsrc) J[f[^̓ǂݍݒEOFɂȂ܂");
  if ( ch!='[' )
    err("(getsrc) J[f[^̃f[^ [ Ŏn܂Ă܂");
  
  color = malloc(0) ;
  i = 0 ;
  while( 1 ) {
    if ( (ch=skip(fp)) == -1 ) {
      err("(getsrc) J[f[^̓ǂݍݒEOFɂȂ܂");
    }
    if ( ch==']' ) break;
    ungetc(ch,fp);
    
    color = realloc(color,sizeof(SHADE)*(i+1));
    
    
    cp = &(color[i].pc) ;
    fscanf( fp, "%lf%lf%lf", &(cp->r),&(cp->g),&(cp->b) ) ;
    get_map( fp, &(color[i].cmap) );
    
    cp = &(color[i].ref) ;
    fscanf( fp, "%lf%lf%lf", &(cp->r),&(cp->g),&(cp->b) ) ;
    get_map( fp, &(color[i].rmap) );
    
    cp = &(color[i].refr) ;
    fscanf( fp, "%lf%lf%lf", &(cp->r),&(cp->g),&(cp->b) ) ;
    get_map( fp, &(color[i].rrmap) );
    
    fscanf( fp, "%lf", &(color[i].n) ) ;
    get_map( fp, &(color[i].nmap) );
    
    fscanf( fp, "%lf", &(color[i].half) ) ;
    get_map( fp, &(color[i].hmap) );
    
    fscanf( fp, "%lf", &(color[i].b) ) ;
    get_map( fp, &(color[i].bmap) );
    
    fscanf( fp, "%d", &(color[i].styp) ) ;
    switch ( color[i].styp ) {
      case 0 : 
        if ((speck1=(SPECK1 *)malloc( sizeof(SPECK1) ))==NULL) 
          err("(getsrc) [܂");
        
        fscanf( fp, "%lf", &( (*speck1).high) ) ;
        get_map( fp, &((*speck1).hmap) );
        
        
        fscanf( fp, "%lf", &( (*speck1).k) ) ;
        get_map( fp, &((*speck1).kmap) );
        
        
        color[i].spara=(void *)speck1;
        break;
        
        
        
        
      case 1 :
        if ((speck2=(SPECK2 *)malloc( sizeof(SPECK2) ))==NULL) 
          err("(getsrc) [܂");
        
        fscanf( fp, "%lf%lf%lf", &( ((*speck2).ref).r), &( ((*speck2).ref).g), &( ((*speck2).ref).b) ) ;
        get_map( fp, &((*speck2).rmap) );
        
        
        fscanf( fp, "%lf", &( (*speck2).n) ) ;
        get_map( fp, &((*speck2).nmap) );
        
        
        fscanf( fp, "%lf", &( (*speck2).f) ) ;
        get_map( fp, &((*speck2).fmap) );
        
        
        color[i].spara=(void *)speck2;
        break;
        
        
        
      case 2 :
        if ((speck3=(SPECK3 *)malloc( sizeof(SPECK3) ))==NULL) 
          err("(getsrc) [܂");
        
        fscanf( fp, "%lf%lf%lf", &( ((*speck3).ref).r), &( ((*speck3).ref).g), &( ((*speck3).ref).b) ) ;
        get_map( fp, &((*speck3).rmap) );
        
        
        fscanf( fp, "%lf%lf%lf%lf%lf%lf",&((*speck3).px),&((*speck3).py),&((*speck3).pz),&((*speck3).vx),&((*speck3).vy),&((*speck3).vz) );
        
        
        fscanf( fp, "%lf", &( (*speck3).a) ) ;
        get_map( fp, &((*speck3).amap) );
        
        
        fscanf( fp, "%lf", &( (*speck3).b) ) ;
        get_map( fp, &((*speck3).bmap) );
        
        
        fscanf( fp, "%lf", &( (*speck3).c) ) ;
        get_map( fp, &((*speck3).cmap) );
        
        
        color[i].spara=(void *)speck3;
        break;
        
        
        
        
      case 3 :
        if ((speck4=(SPECK4 *)malloc( sizeof(SPECK4) ))==NULL) 
          err("(getsrc) [܂");
        
        fscanf( fp, "%lf%lf%lf", &( ((*speck4).ref).r), &( ((*speck4).ref).g), &( ((*speck4).ref).b) ) ;
        get_map( fp, &((*speck4).rmap) );
        
        
        
        fscanf( fp, "%lf%lf%lf",&((*speck4).vx),&((*speck4).vy),&((*speck4).vz) );
        
        
        fscanf( fp, "%lf", &( (*speck4).a) ) ;
        get_map( fp, &((*speck4).amap) );
        
        
        fscanf( fp, "%lf", &( (*speck4).b) ) ;
        get_map( fp, &((*speck4).bmap) );
        
        
        fscanf( fp, "%lf", &( (*speck4).c) ) ;
        get_map( fp, &((*speck4).cmap) );
        
        
        color[i].spara=(void *)speck4;
        break;
        
        
        
    }
    
    
    
    
    i++;
  }
  colornum = i;
  
  sprintf(msg,"%ld ̐̕Fݒ肳܂B",colornum);
  mes(msg);
  
  
  
  if ( skip(fp) != '[' ){
    err("(getsrc) v~eBuf[^ '[' Ŏn܂Ă܂");
  }
  
  pr = malloc(0);
  
  i=0;
  unit(mtx_tmp1);
  unit(mtx_tmp2);
  mes("IuWFNgf[^ǂݍ݂܂B");
  or_levels(fp,&i,mtx_tmp1,mtx_tmp2);
  
  primnum=i;
  
  
  fclose( fp ) ;
  
#ifdef DEBUG
fprintf( stderr, "Number of primitives:%d\n", primnum ) ;
fprintf( stderr, "Source reading completed\n" ) ;
#endif
}


void or_levels(FILE *fp,int *i,MATRIX mtx_tmp1,MATRIX mtx_tmp2)
{
MATRIX mtx1,mtx2,mtx1t,mtx2t;
int ch1;
PRIM *pp;

  pr = realloc(pr,sizeof(PRIM)*((*i)+1));
  
  pp = &(pr[*i]) ;
  pp->link = 1;
  (*i)++;
  
  mes("[");
  
  
  mtx_copy(mtx1,mtx_tmp1);
  mtx_copy(mtx2,mtx_tmp2);
  
  
  while(1) {
  
    pr = realloc(pr,sizeof(PRIM)*((*i)+1));
    
    get_trans(fp,mtx1t,mtx2t);
    mmul1(mtx1,mtx1t);
    mmul2(mtx2t,mtx2);
    
    if ( (ch1=skip(fp)) == -1 ) {
      err("(or_levels) ORubN̒EOFɂȂ܂");
      exit(1);
    }
    switch (ch1) {
      case '[' :
        or_levels(fp,i,mtx1,mtx2);
        break;
      case '{' :
        and_levels(fp,i,mtx1,mtx2);
        break;
      case '(' :
        range_levels(fp,i,mtx1,mtx2);
        break;
      case ']' :
        pp = &(pr[*i]);
        pp->link = -1;
        (*i)++;
        mes("]");
        return;
      case '}' :
      case ')' :
        err("(or_levels) ORubN ] ŏIĂ܂");
        exit(1);
      default :
        ungetc(ch1,fp);
        get_prim(fp,i,mtx1,mtx2);
        break;
    }
  }
}


void and_levels(FILE *fp,int *i,MATRIX mtx_tmp1,MATRIX mtx_tmp2)
{
MATRIX mtx1,mtx2,mtx1t,mtx2t;
int ch1;
PRIM *pp;

  pr = realloc(pr,sizeof(PRIM)*((*i)+1));
  
  pp = &(pr[*i]) ;
  pp->link = 2;
  (*i)++;
  
  mes("{");
  
  mtx_copy(mtx1,mtx_tmp1);
  mtx_copy(mtx2,mtx_tmp2);
  
  
  while(1) {
  
    pr = realloc(pr,sizeof(PRIM)*((*i)+1));
    
    get_trans(fp,mtx1t,mtx2t);
    mmul1(mtx1,mtx1t);
    mmul2(mtx2t,mtx2);
    
    if ( (ch1=skip(fp)) == -1 ) {
      err("(and_levels) ANDubN̒EOFɂȂ܂");
      exit(1);
    }
    switch (ch1) {
      case '[' :
        or_levels(fp,i,mtx1,mtx2);
        break;
      case '{' :
        and_levels(fp,i,mtx1,mtx2);
        break;
      case '(' :
        range_levels(fp,i,mtx1,mtx2);
        break;
      case '}' :
        pp = &(pr[*i]);
        pp->link = -2;
        (*i)++;
        mes("}");
        return;
      case ']' :
      case ')' :
        err("(and_levels) ANDubN } ŏIĂ܂");
        exit(1);
      default :
        ungetc(ch1,fp);
        get_prim(fp,i,mtx1,mtx2);
        break;
    }
  }
}


void range_levels(FILE *fp,int *i,MATRIX mtx_tmp1,MATRIX mtx_tmp2)
{
MATRIX mtx1,mtx2,mtx1t,mtx2t;
int ch1,pt;
PRIM *pp;

  pr = realloc(pr,sizeof(PRIM)*((*i)+1));
  
  pp = &(pr[*i]) ;
  pp->link = 3;
  
  mes("(");
  
  
  pp->sgn = 1 ;
  fscanf(fp,"%d", &pt) ;
  pp->ptyp = pt ;
  mtx_copy( pp->mtx1 , mtx_tmp1 );
  mtx_copy( pp->mtx2 , mtx_tmp2 );
  macros(fp, pp->a, pt ) ;/* primitive param macro */
  
  (*i)++;
  
  
  mtx_copy(mtx1,mtx_tmp1);
  mtx_copy(mtx2,mtx_tmp2);
  
  
  while(1) {
  
    pr = realloc(pr,sizeof(PRIM)*((*i)+1));
    
    get_trans(fp,mtx1t,mtx2t);
    mmul1(mtx1,mtx1t);
    mmul2(mtx2t,mtx2);
    
    if ( (ch1=skip(fp)) == -1 ) {
      err("(range_levels) RANGEubN̒EOFɂȂ܂");
      exit(1);
    }
    switch (ch1) {
      case '[' :
        or_levels(fp,i,mtx1,mtx2);
        break;
      case '{' :
        and_levels(fp,i,mtx1,mtx2);
        break;
      case '(' :
        range_levels(fp,i,mtx1,mtx2);
        break;
      case ')' :
        pp = &(pr[*i]);
        pp->link = -3;
        (*i)++;
        mes(")");
        return;
      case ']' :
      case '}' :
        err("(range levels) RANGEubN ) ŏIĂ܂");
        exit(1);
      default :
        ungetc(ch1,fp);
        get_prim(fp,i,mtx1,mtx2);
        break;
    }
  }
}



void get_prim(FILE *fp,int *i,MATRIX mtx_tmp1,MATRIX mtx_tmp2)
{
MATRIX mtx1,mtx2,mtx1t,mtx2t;
int ch1,pt;
PRIM *pp;
void **back;
MAP *map_tmp;

  pr = realloc(pr,sizeof(PRIM)*((*i)+1));
  
  pp = &(pr[*i]) ;
  (*i)++;
  pp->link = 0;
  fscanf( fp, "%d", &(pp->sgn)) ;
  
  mtx_copy(mtx1,mtx_tmp1);
  mtx_copy(mtx2,mtx_tmp2);
  get_trans(fp,mtx1t,mtx2t);
  mmul1(mtx1,mtx1t);
  mmul2(mtx2t,mtx2);
  mtx_copy( pp->mtx1 , mtx1 );
  mtx_copy( pp->mtx2 , mtx2 );
  fscanf( fp, "%d", &(pp->sh)) ;
  
  if ( (pp->sh >= colornum) || (pp->sh < 0) )
    err("(getsrc) `ĂȂJ[io[ł");
  
  
  
/*  fscanf( fp, "%d", &ii ) ;*/
  pp->shmap=NULL;
  back=( &(  pp->shmap  ) );
  
  if ( (ch1=skip(fp)) == -1 ) { 
    err("(get_prim) v~eBuf[^̓rEOFɂȂ܂");
    exit(1);
  }
  if ( ch1 == '<' ) {
    if ( ((*back)=(void *)malloc( sizeof(MAP) ))==NULL )
    {
       err("(get_prim) [܂");
       exit(1);
    }
    else
    {
      map_tmp=(MAP *)(*back);
      (*map_tmp).next=NULL;
/*
      back=&((*map_tmp).next);
      mtx_copy(mtx1,mtx_tmp1);
      mtx_copy(mtx2,mtx_tmp2);
      get_trans(fp,mtx1t,mtx2t);
      mmul1(mtx1,mtx1t);
      mmul2(mtx2t,mtx2);
      mtx_copy( (*map_tmp).mtx1 , mtx_tmp1 );
      mtx_copy( (*map_tmp).mtx2 , mtx_tmp2 );
*/
      get_trans(fp,mtx1t,mtx2t);
      mtx_copy( (*map_tmp).mtx1 , mtx1t );
      mtx_copy( (*map_tmp).mtx2 , mtx2t );

      fscanf( fp , "%d%lf%d",&((*map_tmp).mapnum),&((*map_tmp).k),&((*map_tmp).mapmode) );
      switch ( (*map_tmp).mapmode ) {
        case 0 :
          err("(get_prim) J[io[}bsOɂ͑S}bsO͎g܂");
          exit(1);
        case 1 :
        case 2 :
        case 3 :
        case 4 :
          fscanf (fp , "%lf%lf%lf%lf%lf%lf%lf%lf",&((*map_tmp).u1),&((*map_tmp).v1),&((*map_tmp).u2),&((*map_tmp).v2),&((*map_tmp).u1a),&((*map_tmp).v1a),&((*map_tmp).u2a),&((*map_tmp).v2a) );
          break;
        default :
          err("(get_prim) T|[gĂȂ}bsO[hł");
          exit(1);
      }
      
      if ( (ch1=skip(fp)) == -1 ) { 
        err("(get_prim) v~eBuf[^̓rEOFɂȂ܂");
        exit(1);
      }
      if ( ch1 != '>' ) {
        err("(get_prim) J[io[}bsO > ŏIĂ܂");
        return;
      }
      
      
    }
  }
  else
  {
    ungetc(ch1,fp);
  }
  
  
  
  
  
  fscanf(fp,"%d", &pt) ;
  pp->ptyp = pt ;
  
  
  macros(fp, pp->a, pt ) ;/* primitive param macro */

}








void macros( FILE *fp, float *a, int t )
{
float x,y,z ;
float a0,a1,a2,a3,a4,a5,a6,a7,a8,a9 ;
float tmp,tmp2 ;
char msg[256] ;

  fscanf( fp, "%lf%lf%lf", &x, &y, &z ) ;/* x,y,z */
  switch( t ) {
    case 0:/* a0-a9 sonomama */
      fscanf(fp, "%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf",
               &a0,&a1,&a2,&a3,&a4,&a5,&a6,&a7,&a8,&a9 );
      sprintf(msg,"0:񎟋Ȗ  (%lf,%lf,%lf),%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf",x,y,z,a0,a1,a2,a3,a4,a5,a6,a7,a8,a9);
      mes(msg);
      break ;
    case 1:/* plane */
      fscanf(fp, "%lf%lf%lf", &a6,&a7,&a8 ) ;
      sprintf(msg,"2:  (%lf,%lf,%lf),%lf,%lf,%lf",x,y,z,a6,a7,a8);
      mes(msg);
      temp = sqrt(a6*a6+a7*a7+a8*a8) ; a6/=temp;a7/=temp;a8/=temp ;
      a0 = a1 = a2 = a3 = a4 = a5 = a9 = 0 ;
      break ;
    case 2:/* sphere */
      fscanf(fp, "%lf", &a9 ) ;
      sprintf(msg,"2:  (%lf,%lf,%lf),%lf",x,y,z,a9);
      mes(msg);
      a0 = a1 = a2 = 1 ;
      a3 = a4 = a5 = a6 = a7 = a8 =  0 ;
      a9 = -(a9 * a9) ;
      break ;
    case 3:/* elp */
      fscanf(fp, "%lf%lf%lf", &a0,&a1,&a2 ) ;
      sprintf(msg,"3:ȉ~  (%lf,%lf,%lf),%lf,%lf,%lf",x,y,z,a0,a1,a2);
      mes(msg);
      a0 = fsign(a0)/(a0*a0) ; a1 = fsign(a1)/(a1*a1) ; a2 = fsign(a2)/(a2*a2) ;
      a3 = a4 = a5 = a6 = a7 = a8 = 0 ;
      a9 = -1 ;
      break ;
    case 4:/* cone */
      fscanf(fp,"%lf%lf%lf%lf", &a6,&a7,&a8,&a9 ) ;
      sprintf(msg,"4:~  (%lf,%lf,%lf),%lf,%lf,%lf,%lf",x,y,z,a6,a7,a8,a9);
      mes(msg);
      tmp = sqrt(a6*a6+a7*a7+a8*a8) ;
      a6 /= tmp ; a7 /= tmp ; a8 /=tmp ;
      a9 = 1+ a9*a9 ;
      a0 = 1 - a9*a6*a6 ; a1 = 1 - a9*a7*a7 ; a2 = 1 - a9*a8*a8 ;
      a3 = -2*a9*a6*a7 ; a4 = -2*a9*a7*a8 ; a5 = -2*a9*a8*a6 ;
      a6 = a7 = a8 = 0 ;
      break ;
    case 5:/* sylinder */
      fscanf(fp,"%lf%lf%lf%lf", &a6,&a7,&a8,&a9 ) ;
      sprintf(msg,"5:~  (%lf,%lf,%lf),%lf,%lf,%lf,%lf",x,y,z,a6,a7,a8,a9);
      mes(msg);
      tmp = sqrt(a6*a6+a7*a7+a8*a8) ;
      a6 /= tmp ; a7 /= tmp ; a8 /=tmp ;
      a9 = - a9*a9 ;
      a0 = 1 - a6*a6 ; a1 = 1 - a7*a7 ; a2 = 1 - a8*a8 ;
      a3 = -2*a6*a7 ; a4 = -2*a7*a8 ; a5 = -2*a8*a6 ;
      a6 = a7 = a8 = 0 ;
      break ;
    case 6:/* oval */
      fscanf(fp,"%lf%lf%lf%lf%lf", &a6,&a7,&a8,&tmp,&tmp2 ) ;
      sprintf(msg,"6:ȉ~  (%lf,%lf,%lf),%lf,%lf,%lf,%lf,%lf",x,y,z,a6,a7,a8,tmp,tmp2);
      mes(msg);
      a9 = sqrt(a6*a6+a7*a7+a8*a8) ;
      a6 /= a9 ; a7 /= a9 ; a8 /=a9 ;
      tmp = tmp*tmp ; tmp2 = tmp2*tmp2 ; a9 = tmp - tmp2 ;
      a0 = tmp - a9*a6*a6 ; a1 = tmp - a9*a7*a7 ; a2 = tmp - a9*a8*a8 ;
      a3 = -2*a9*a6*a7 ; a4 = -2*a9*a7*a8 ; a5 = -2*a9*a8*a6 ;
      a6 = a7 = a8 = 0 ; a9 = - tmp * tmp2 ;
      break ;
    default :
      err( "(macros) T|[gĂȂv~eBu^Cvł" ) ;
  }
  /* parallel move */
  a9 += a0*x*x + a1*y*y + a2*z*z + a3*x*y + a4*y*z + a5*z*x - a6*x - a7*y -a8*z ;
  a6 += -2*a0*x - a3*y - a5*z ;
  a7 += -2*a1*y - a3*x - a4*z ;
  a8 += -2*a2*z - a4*y - a5*x ;
  
  *a++ = a0 ; *a++ = a1 ; *a++ = a2 ; *a++ = a3 ; *a++ = a4 ; *a++ = a5 ;
  *a++ = a6 ; *a++ = a7 ; *a++ = a8 ; *a   = a9 ;
  
#ifdef DEBUG
fprintf(stderr,"(%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf,%lf)\n",
a0,a1,a2,a3,a4,a5,a6,a7,a8,a9 ) ;
#endif
}


void get_map (FILE *fp,void **map_tmp2)
{
void **back ;
int ch ;
MAP *map_tmp ;
MATRIX mtx_tmp1,mtx_tmp2 ;







/*  fscanf( fp,"%d",&ii);*/
  *map_tmp2 = NULL;
  back = map_tmp2;
  
  if ( (ch=skip(fp)) == -1 ) { 
    err("(get_map) }bsOf[^̓rEOFɂȂ܂");
    exit(1);
  }
  if ( ch != '<' ) {
    ungetc(ch,fp);
    return;
  }
/*  for (iii=0;iii<ii;iii++)*/
  while (1)
  {
    if ( ((*back)=(void *)malloc( sizeof(MAP) ))==NULL )
    {
      err("(get_map) [܂");
    }
    else
    {
      map_tmp=(MAP *)(*back);
      (*map_tmp).next=NULL;
      back=&((*map_tmp).next);
      get_trans(fp,mtx_tmp1,mtx_tmp2);
      mtx_copy( (*map_tmp).mtx1 , mtx_tmp1 );
      mtx_copy( (*map_tmp).mtx2 , mtx_tmp2 );
      fscanf( fp , "%d%lf%d",&((*map_tmp).mapnum),&((*map_tmp).k),&((*map_tmp).mapmode) );
      switch ( (*map_tmp).mapmode ) {
        case 0 :
          fscanf (fp , "%lf",&( (*map_tmp).u1) );
          break;
        case 1 :
        case 2 :
        case 3 :
        case 4 :
          fscanf (fp , "%lf%lf%lf%lf%lf%lf%lf%lf",
                     &((*map_tmp).u1),&((*map_tmp).v1),
                     &((*map_tmp).u2),&((*map_tmp).v2),
                     &((*map_tmp).u1a),&((*map_tmp).v1a),
                     &((*map_tmp).u2a),&((*map_tmp).v2a) );
          break;
        default :
          err("(get_map) T|[gĂȂ}bsO[hł");
          exit(1);
      }
    }
    if ( (ch=skip(fp)) == -1 ) { 
      err("(get_map) }bsOf[^̓rEOFɂȂ܂");
      exit(1);
    }
    if ( ch == '>' ) {
      return;
    }
    ungetc(ch,fp);
    
  }


}




void get_trans (FILE *fp,MATRIX mtx1,MATRIX mtx2)
{
int ch1;
float r;
MATRIX mtx;

  unit(mtx1);
  unit(mtx2);
  while(1){
    if ( (ch1=skip(fp)) == -1 ) { 
      err("(get_trans) ړR}h̓rEOFɂȂ܂");
      exit(1);
    }
    if ( ch1 != ':' ) {
      ungetc(ch1,fp);
      return;
    }
    
    if ( (ch1=getc(fp)) == -1 ) {
      err("(get_trans) ړR}h̓rEOFɂȂ܂");
      exit(1);
    }
    ch1 = tolower(ch1);
    switch (ch1) {
      case 'r' :
        if ( (ch1=getc(fp)) == -1 ) {
          err("(get_trans) ړR}h̓rEOFɂȂ܂");
          exit(1);
        }
        ch1 = tolower(ch1);
        switch (ch1) {
          case 'x' :
            fscanf(fp,"%lf",&r);
            rotx(mtx,r);
            mmul2(mtx,mtx2);
            rotx(mtx,-r);
            mmul1(mtx1,mtx);
            break;
          case 'y' :
            fscanf(fp,"%lf",&r);
            roty(mtx,r);
            mmul2(mtx,mtx2);
            roty(mtx,-r);
            mmul1(mtx1,mtx);
            break;
          case 'z' :
            fscanf(fp,"%lf",&r);
            rotz(mtx,r);
            mmul2(mtx,mtx2);
            rotz(mtx,-r);
            mmul1(mtx1,mtx);
            break;
          default :
            err("(get_trans) T|[gĂȂړR}hł");
            exit(1);
        }
        break;
      
      
      case 'm' :
        if ( (ch1=getc(fp)) == -1 ) {
          err("(get_trans) ړR}h̓rEOFɂȂ܂");
          exit(1);
        }
        ch1 = tolower(ch1);
        switch (ch1) {
          case 'x' :
            fscanf(fp,"%lf",&r);
            movx(mtx,r);
            mmul2(mtx,mtx2);
            movx(mtx,-r);
            mmul1(mtx1,mtx);
            break;
          case 'y' :
            fscanf(fp,"%lf",&r);
            movy(mtx,r);
            mmul2(mtx,mtx2);
            movy(mtx,-r);
            mmul1(mtx1,mtx);
            break;
          case 'z' :
            fscanf(fp,"%lf",&r);
            movz(mtx,r);
            mmul2(mtx,mtx2);
            movz(mtx,-r);
            mmul1(mtx1,mtx);
            break;
          default :
            err("(get_trans) T|[gĂȂړR}hł");
            exit(1);
        }
        break;
      
      
      case 's' :
        if ( (ch1=getc(fp)) == -1 ) {
          err("(get_trans) ړR}h̓rEOFɂȂ܂");
          exit(1);
        }
        ch1 = tolower(ch1);
        switch (ch1) {
          case 'x' :
            fscanf(fp,"%lf",&r);
            scalx(mtx,1.0/r);
            mmul2(mtx,mtx2);
            scalx(mtx,1.0/r);
            mmul1(mtx1,mtx);
            break;
          case 'y' :
            fscanf(fp,"%lf",&r);
            scaly(mtx,1.0/r);
            mmul2(mtx,mtx2);
            scaly(mtx,1.0/r);
            mmul1(mtx1,mtx);
            break;
          case 'z' :
            fscanf(fp,"%lf",&r);
            scalz(mtx,1.0/r);
            mmul2(mtx,mtx2);
            scalz(mtx,1.0/r);
            mmul1(mtx1,mtx);
            break;
          default :
            err("(get_trans) T|[gĂȂړR}hł");
            exit(1);
        }
        break;
      
      
      default :
        err("(get_trans) T|[gĂȂړR}hł");
        exit(1);
    }
  }

}





int skip (FILE *f)
{
int ch;

  while ( isspace(ch=getc(f)) && ch!=EOF );
  return (ch);
}

void mtx_copy(MATRIX m1,MATRIX m2)
{
int i,j;

  for(i=0;i<4;i++)
    for(j=0;j<4;j++)
      m1[i][j]=m2[i][j];
}

void unit(MATRIX m)
{
int i,j;

  for (i=0;i<4;i++)
    for (j=0;j<4;j++)
      if (i!=j) {m[i][j] = 0;} else {m[i][j] = 1;};
}

void trans_it(FV *p,MATRIX m)
{
float x,y,z,w;

  x = (*p).x * m[0][0] + (*p).y * m[1][0] + (*p).z * m[2][0] + m[3][0];
  y = (*p).x * m[0][1] + (*p).y * m[1][1] + (*p).z * m[2][1] + m[3][1];
  z = (*p).x * m[0][2] + (*p).y * m[1][2] + (*p).z * m[2][2] + m[3][2];
  w = (*p).x * m[0][3] + (*p).y * m[1][3] + (*p).z * m[2][3] + m[3][3];
  (*p).x = x/w;
  (*p).y = y/w;
  (*p).z = z/w;
}

void trans_it2(FV *p,MATRIX m)
{
float x,y,z,w;

  x = (*p).x * m[0][0] + (*p).y * m[1][0] + (*p).z * m[2][0] + m[3][0];
  y = (*p).x * m[0][1] + (*p).y * m[1][1] + (*p).z * m[2][1] + m[3][1];
  z = (*p).x * m[0][2] + (*p).y * m[1][2] + (*p).z * m[2][2] + m[3][2];
  w = (*p).x * m[0][3] + (*p).y * m[1][3] + (*p).z * m[2][3] + m[3][3];
  (*p).x = x/w - m[3][0]/m[3][3];
  (*p).y = y/w - m[3][1]/m[3][3];
  (*p).z = z/w - m[3][2]/m[3][3];
}


void mmul2 (MATRIX r,MATRIX m)
{
int i,j,k;
double t;
MATRIX n;

  for (i=0;i<4;i++) {
    for (j=0;j<4;j++) {
      t=0;
      for (k=0;k<4;k++) 
        t += r[i][k] * m[k][j];
      n[i][j] = t;
    }
  }
  for (i=0;i<4;i++) {
    for (j=0;j<4;j++) {
      m[i][j] = n[i][j];
    }
  }
}

void mmul1 (MATRIX m,MATRIX r)
{
int i,j,k;
double t;
MATRIX n;

  for (i=0;i<4;i++) {
    for (j=0;j<4;j++) {
      t=0;
      for (k=0;k<4;k++) 
        t += m[i][k] * r[k][j];
      n[i][j] = t;
    }
  }
  for (i=0;i<4;i++) {
    for (j=0;j<4;j++) {
      m[i][j] = n[i][j];
    }
  }
}

void rotx(MATRIX m,float r)
{
  unit(m);
  r *= PI /180;
  m[1][1] = m[2][2] = cos (r);
  m[1][2] = -( m[2][1] = sin (r) );
}

void roty(MATRIX m,float r)
{
  unit(m);
  r *= PI /180;
  m[2][2] = m[0][0] = cos (r);
  m[2][0] = -( m[0][2] = sin (r) );
}

void rotz(MATRIX m,float r)
{
  unit(m);
  r *= PI /180;
  m[0][0] = m[1][1] = cos (r);
  m[0][1] = -( m[1][0] = sin (r) );
}

void movx(MATRIX m,float r)
{
  unit(m);
  m[3][0] = r;
}

void movy(MATRIX m,float r)
{
  unit(m);
  m[3][1] = r;
}

void movz(MATRIX m,float r)
{
  unit(m);
  m[3][2] = r;
}

void scalx(MATRIX m,float r)
{
  unit(m);
  m[0][0] = r;
}

void scaly(MATRIX m,float r)
{
  unit(m);
  m[1][1] = r;
}

void scalz(MATRIX m,float r)
{
  unit(m);
  m[2][2] = r;
}




void loadmap(int n,char *filename)
{

FILE *fp;
int i,i1,i2,i3,i4;
char fn[80],fn2[80],ext[4],*temp;
IFD_E ifd_tmp;
unsigned short int v;


  if (  (temp = strchr(filename,'.')) == NULL  ) 
    err("(loadmap) OtBbN̊gq܂");
  temp++;
  strncpy(ext,temp,3);
  strncpy(fn,filename, strcspn(filename,".") );
  fn[strcspn(filename,".")]=0;
  
  if ( strcmp(ext,"tif")==0 || strcmp(ext,"TIF")==0 )
  {
    if ( (fp=fopen(filename,"rb"))==NULL )
      err("(loadmap) .TIFt@C݂܂");
    for (i=0; i<4; i++) getc(fp);
    fread ( (char *)(&i1),4,1,fp );
    
    
    fseek(fp,i1,0);
    i2 = getc(fp); i2 += getc(fp)*256 ;
    
    
    for (i=0; i<i2; i++)
    {
      fread ( (char *)(&ifd_tmp),12,1,fp ) ;
      
      switch ( ifd_tmp.tag )
      {
        case 0x100 :
          gx[n] = ifd_tmp.value;
          break;
        case 0x101 :
          gy[n] = ifd_tmp.value;
          break;
        case 0x102 :
          i3 = (gx[n]*gy[n]*ifd_tmp.value+8)/8;
          switch ( ifd_tmp.value )
          {
            case 1 :
              maptyp[n] = 0 ;
              break;
            case 4 :
              maptyp[n] = 1 ;
              break;
            case 8 :
              maptyp[n] = 2 ;
              break;
            case 16 :
              maptyp[n] = 3 ;
              break;
          };
          break;
        case 0x103 :
          if ( ifd_tmp.value != 1 )
            err("(loadmap) k`TIFF͓ǂݍ߂܂");
          break;
        case 0x106 :
          if ( ifd_tmp.value == 3 )
          {
            i4 = 1;
          }
          else
          {
            i4 = 0;
          };
          break;
        case 0x111 :
          i1 = ifd_tmp.value ;
          break;
        case 0x117 :
          i3 = ifd_tmp.value ;
          break;
        case 0x140 :
          i4 = ifd_tmp.value ;
          break;
      };
    };
    
    
    switch ( maptyp[n] )
    {
      case 0 :
        fseek(fp,i1,0);
        if ( (map[n]=(void *)malloc( i3 ))==NULL )
          err("(loadmap) [܂");
        fread ( (char *)(map[n]),i3,1,fp ) ;
        break;
      case 1 :
        fseek(fp,i1,0);
        if ( (map[n]=(void *)malloc( i3 + sizeof(FRGB)*16 ))==NULL )
          err("(loadmap) [܂");
        fread ( (char *)(map[n]) + sizeof(FRGB)*16 ,i3,1,fp ) ;
        
        if ( i4 == 0 )
        {
          ( (FRGB *)(map[n]) )[0].r = 0/15.0;
          ( (FRGB *)(map[n]) )[0].g = 0/15.0;
          ( (FRGB *)(map[n]) )[0].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[1].r = 0/15.0;
          ( (FRGB *)(map[n]) )[1].g = 0/15.0;
          ( (FRGB *)(map[n]) )[1].b = 7/15.0;
          
          ( (FRGB *)(map[n]) )[2].r = 7/15.0;
          ( (FRGB *)(map[n]) )[2].g = 0/15.0;
          ( (FRGB *)(map[n]) )[2].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[3].r = 7/15.0;
          ( (FRGB *)(map[n]) )[3].g = 0/15.0;
          ( (FRGB *)(map[n]) )[3].b = 7/15.0;
          
          ( (FRGB *)(map[n]) )[4].r = 0/15.0;
          ( (FRGB *)(map[n]) )[4].g = 7/15.0;
          ( (FRGB *)(map[n]) )[4].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[5].r = 0/15.0;
          ( (FRGB *)(map[n]) )[5].g = 7/15.0;
          ( (FRGB *)(map[n]) )[5].b = 7/15.0;
          
          ( (FRGB *)(map[n]) )[6].r = 7/15.0;
          ( (FRGB *)(map[n]) )[6].g = 7/15.0;
          ( (FRGB *)(map[n]) )[6].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[7].r = 10/15.0;
          ( (FRGB *)(map[n]) )[7].g = 10/15.0;
          ( (FRGB *)(map[n]) )[7].b = 10/15.0;
          
          ( (FRGB *)(map[n]) )[8].r = 4/15.0;
          ( (FRGB *)(map[n]) )[8].g = 4/15.0;
          ( (FRGB *)(map[n]) )[8].b = 4/15.0;
          
          ( (FRGB *)(map[n]) )[9].r = 0/15.0;
          ( (FRGB *)(map[n]) )[9].g = 0/15.0;
          ( (FRGB *)(map[n]) )[9].b = 15/15.0;
          
          ( (FRGB *)(map[n]) )[10].r = 15/15.0;
          ( (FRGB *)(map[n]) )[10].g = 0/15.0;
          ( (FRGB *)(map[n]) )[10].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[11].r = 15/15.0;
          ( (FRGB *)(map[n]) )[11].g = 0/15.0;
          ( (FRGB *)(map[n]) )[11].b = 15/15.0;
          
          ( (FRGB *)(map[n]) )[12].r = 0/15.0;
          ( (FRGB *)(map[n]) )[12].g = 15/15.0;
          ( (FRGB *)(map[n]) )[12].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[13].r = 0/15.0;
          ( (FRGB *)(map[n]) )[13].g = 15/15.0;
          ( (FRGB *)(map[n]) )[13].b = 15/15.0;
          
          ( (FRGB *)(map[n]) )[14].r = 15/15.0;
          ( (FRGB *)(map[n]) )[14].g = 15/15.0;
          ( (FRGB *)(map[n]) )[14].b = 0/15.0;
          
          ( (FRGB *)(map[n]) )[15].r = 15/15.0;
          ( (FRGB *)(map[n]) )[15].g = 15/15.0;
          ( (FRGB *)(map[n]) )[15].b = 15/15.0;
        }
        else
        {
          fseek(fp,i4,0);
          for (i4=0; i4<16; i4++)
          {
            fread ( &v ,2,1,fp ) ;
            ( (FRGB *)(map[n]) )[i4].r = (float)(v)/(float)(0xffff);
          }
          for (i4=0; i4<16; i4++)
          {
            fread ( &v ,2,1,fp ) ;
            ( (FRGB *)(map[n]) )[i4].g = (float)(v)/(float)(0xffff);
          }
          for (i4=0; i4<16; i4++)
          {
            fread ( &v ,2,1,fp ) ;
            ( (FRGB *)(map[n]) )[i4].b = (float)(v)/(float)(0xffff);
          }
        };
        break;
      case 2 :
        fseek(fp,i1,0);
        if ( (map[n]=(void *)malloc( i3 + sizeof(FRGB)*256 ))==NULL )
          err("(loadmap) [܂");
        fread ( ((char *)(map[n])) + sizeof(FRGB)*256 ,i3,1,fp ) ;
        
        if ( i4 == 0 )
        {
          for(i1=0; i1<256; i1++)
          {
            ( (FRGB *)(map[n]) )[i1].r = ((float)i1)/255;
            ( (FRGB *)(map[n]) )[i1].g = ((float)i1)/255;
            ( (FRGB *)(map[n]) )[i1].b = ((float)i1)/255;
          };
        }
        else
        {
          fseek(fp,i4,0);
          for (i4=0; i4<256; i4++)
          {
            fread ( &v ,2,1,fp ) ;
            ( (FRGB *)(map[n]) )[i4].r = (float)(v)/(float)(0xffff);
          }
          for (i4=0; i4<256; i4++)
          {
            fread ( &v ,2,1,fp ) ;
            ( (FRGB *)(map[n]) )[i4].g = (float)(v)/(float)(0xffff);
          }
          for (i4=0; i4<256; i4++)
          {
            fread ( &v ,2,1,fp ) ;
            ( (FRGB *)(map[n]) )[i4].b = (float)(v)/(float)(0xffff);
          }
        };
        break;
      case 3 :
        fseek(fp,i1,0);
        if ( (map[n]=(void *)malloc( i3 ))==NULL )
          err("(loadmap) [܂");
        fread ( (char *)(map[n]),i3,1,fp ) ;
        break;
    };
    
    fclose(fp);
    
  }
  else if ( strcmp(ext,"fal")==0 || strcmp(ext,"FAL")==0 )
  {
    maptyp[n] = 4;
    strcpy(fn2,fn);
    strcat(fn2,".fal");
    strcat(fn,".rgb");
    if ( (fp=fopen(fn2,"r"))==NULL )
      err("(loadmap) .FALt@C݂܂");
    fscanf(fp,"%*s%ld%ld",&gx[n],&gy[n]);
    fclose(fp);
    
    if ( (fp=fopen(fn,"rb"))==NULL )
      err("(loadmap) .RGBt@C݂܂");
    if ( (map[n]=(void *)malloc( gx[n]*gy[n]*3 ))==NULL )
      err("(loadmap) [܂");
    fread ( (char *)(map[n]),gx[n]*gy[n]*3,1,fp ) ;
    
    fclose(fp);
  }
  else
  {
    err("(loadmap) T|[gĂȂgqł");
    exit(1);
  };
  



}
