#include "rt.h"
#include <string.h>

int getmap_col(float x,float y,float z,  float nx,float ny,float nz,  MAP *map_tmp,MATRIX mtx,  float *r,float *g,float *b)
{

int mode,num,tx,ty;
float l,lx,ly,lz,k,u1,v1,u2,v2,u1a,v1a,u2a,v2a;
MATRIX mtx_tmp;
FV p_tmp;
FRGB val;


  mtx_copy(mtx_tmp,mtx) ;
  mmul1( mtx_tmp,(*map_tmp).mtx1 );
  
  p_tmp.x = x; p_tmp.y = y; p_tmp.z = z;
  trans_it(&p_tmp,mtx_tmp);
  x = p_tmp.x; y = p_tmp.y; z = p_tmp.z;
  
  
  
  p_tmp.x = nx; p_tmp.y = ny; p_tmp.z = nz;
  trans_it2(&p_tmp,mtx_tmp);
  nx = p_tmp.x ; ny = p_tmp.y ; nz = p_tmp.z ;
  
  num=(*map_tmp).mapnum;
  k=(*map_tmp).k;
  mode=(*map_tmp).mapmode;
  u1=(*map_tmp).u1;
  v1=(*map_tmp).v1;
  u2=(*map_tmp).u2;
  v2=(*map_tmp).v2;
  u1a=(*map_tmp).u1a;
  v1a=(*map_tmp).v1a;
  u2a=(*map_tmp).u2a;
  v2a=(*map_tmp).v2a;
  if (u1a>u2a) {
    l=u1a;
    u1a=u2a;
    u2a=l;
  }
  if (v1a>v2a) {
    l=v1a;
    v1a=v2a;
    v2a=l;
  }
  
  switch(mode) {
    case 0:
      x *= u1;
      y *= u1;
      z *= u1;
      
      lx = sqrt(nx*nx);
      ly = sqrt(ny*ny);
      lz = sqrt(nz*nz);
      l  = lx + ly + lz;
      
      tx =( (int)x % gx[num] + gx[num] ) % gx[num];
      ty =( (int)y % gy[num] + gy[num] ) % gy[num];
      val = getmap_col_sub(tx,ty,num);
      *r += (val.r*lz/l*k);
      *g += (val.g*lz/l*k);
      *b += (val.b*lz/l*k);
      
      tx =( (int)y % gx[num] + gx[num] ) % gx[num];
      ty =( (int)z % gy[num] + gy[num] ) % gy[num];
      val = getmap_col_sub(tx,ty,num);
      *r += (val.r*lx/l*k);
      *g += (val.g*lx/l*k);
      *b += (val.b*lx/l*k);
      
      tx =( (int)z % gx[num] + gx[num] ) % gx[num];
      ty =( (int)x % gy[num] + gy[num] ) % gy[num];
      val = getmap_col_sub(tx,ty,num);
      *r += (val.r*ly/l*k);
      *g += (val.g*ly/l*k);
      *b += (val.b*ly/l*k);
      
      break;
      
    case 1:
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (y < v1a) || (y > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      y = fmod( y - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (y+1) * gy[num] )) % gy[num] );
      val = getmap_col_sub(tx,ty,num);
      *r += val.r*k;
      *g += val.g*k;
      *b += val.b*k;
      break;
      
    case 2:
      z = atan2( z , sqrt(x*x+y*y) ) / PI*2;
      x = atan2( y , x ) / PI;
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (z < v1a) || (z > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      z = fmod( z - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (z+1) * gy[num] )) % gy[num] );
      val = getmap_col_sub(tx,ty,num);
      *r += val.r*k;
      *g += val.g*k;
      *b += val.b*k;
      break;
      
    case 3:
      z = sqrt( x*x+y*y );
      x = atan2( y , x ) / PI;
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (z < v1a) || (z > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      z = fmod( z - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (z+1) * gy[num] )) % gy[num] );
      val = getmap_col_sub(tx,ty,num);
      *r += val.r*k;
      *g += val.g*k;
      *b += val.b*k;
      break;
      
    case 4:
      x = atan2( y , x ) / PI;
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (z < v1a) || (z > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      z = fmod( z - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (z+1) * gy[num] )) % gy[num] );
      val = getmap_col_sub(tx,ty,num);
      *r += val.r*k;
      *g += val.g*k;
      *b += val.b*k;
      break;
      
      
    default :
      err("(getmap_col) T|[gĂȂ}bsO[hł");
      
  }
  
  return (1);
}


FRGB getmap_col_sub( int tx, int ty, int num )
{
int v,vr,vg,vb;
FRGB val;

  switch (maptyp[num])
  {
    case 0:
      v = (int)( ((unsigned char *)(((int *)map)[num]))
        [(tx+ty*gx[num])/8] );
      v = (v >> (tx+ty*gx[num])%8) & 0x01;
      val.r = v;
      val.g = v;
      val.b = v;
      break;
    case 1:
      v = (int)( ((unsigned char *)(((int *)map)[num]))
        [(tx+ty*gx[num])/2 + sizeof (FRGB)*16] );
      if ( (tx+ty*gx[num])%2 == 0 )
      {
        v = v & 0x0f;
      }
      else
      {
        v = (v >> 4) & 0x0f;
      };
      val.r = (*(((FRGB *)(((int *)map)[num]))+v)).r;
      val.g = (*(((FRGB *)(((int *)map)[num]))+v)).g;
      val.b = (*(((FRGB *)(((int *)map)[num]))+v)).b;
      break;
    case 2:
      v = (int)( ((unsigned char *)(((int *)map)[num]))
        [tx+ty*gx[num] + sizeof (FRGB)*256] );
      val.r = (*(((FRGB *)(((int *)map)[num]))+v)).r;
      val.g = (*(((FRGB *)(((int *)map)[num]))+v)).g;
      val.b = (*(((FRGB *)(((int *)map)[num]))+v)).b;
      break;
    case 3:
      v = (int)( ((short int *)(((int *)map)[num]))[ tx+ty*gx[num] ] );
      vb = v & 0x001f;
      vr = (v & 0x03e0)>>5;
      vg = (v & 0x7c00)>>10;
      val.r = (double)vr / 31;
      val.g = (double)vg / 31;
      val.b = (double)vb / 31;
      break;
    case 4:
      vr = (int)( ((unsigned char *)(((int *)map)[num]))[(tx+ty*gx[num])*3] );
      vg = (int)( ((unsigned char *)(((int *)map)[num]))[(tx+ty*gx[num])*3+1]);
      vb = (int)( ((unsigned char *)(((int *)map)[num]))[(tx+ty*gx[num])*3+2]);
      val.r = (double)vr / 255;
      val.g = (double)vg / 255;
      val.b = (double)vb / 255;
      break;
    default:
      err("(getmap_col_sub) T|[gĂȂOtBbNf[^ł");
  };
  return (val);
}




int getmap_mono(float x,float y,float z,  float nx,float ny,float nz,  MAP *map_tmp,MATRIX mtx,  float *i)
{
float a1,a2,a3;
  
  a1 = a2 = a3 = 0;
  if ( getmap_col(x,y,z,nx,ny,nz,map_tmp,mtx,&a1,&a2,&a3) == 0 ) return (0);
  *i += (a1 + a2 + a3)/3;
  return (1);
}



int getmap_num(float x,float y,float z,  float nx,float ny,float nz,  MAP *map_tmp,MATRIX mtx)
{

int mode,num,tx,ty;
float l,k,u1,v1,u2,v2,u1a,v1a,u2a,v2a;
MATRIX mtx_tmp;
FV p_tmp;



  mtx_copy(mtx_tmp,mtx) ;
  mmul1( mtx_tmp,(*map_tmp).mtx1 );
  
  p_tmp.x = x; p_tmp.y = y; p_tmp.z = z;
  trans_it(&p_tmp,mtx_tmp);
  x = p_tmp.x; y = p_tmp.y; z = p_tmp.z;
  
  
  
  p_tmp.x = nx; p_tmp.y = ny; p_tmp.z = nz;
  trans_it2(&p_tmp,mtx_tmp);
  nx = p_tmp.x ; ny = p_tmp.y ; nz = p_tmp.z ;
  
  num=(*map_tmp).mapnum;
  k=(*map_tmp).k;
  mode=(*map_tmp).mapmode;
  u1=(*map_tmp).u1;
  v1=(*map_tmp).v1;
  u2=(*map_tmp).u2;
  v2=(*map_tmp).v2;
  u1a=(*map_tmp).u1a;
  v1a=(*map_tmp).v1a;
  u2a=(*map_tmp).u2a;
  v2a=(*map_tmp).v2a;
  if (u1a>u2a) {
    l=u1a;
    u1a=u2a;
    u2a=l;
  }
  if (v1a>v2a) {
    l=v1a;
    v1a=v2a;
    v2a=l;
  }
  
  switch(mode) {
    case 0:
      err("(getmap_num) J[io[}bsOɂ͑S}bsO͎g܂");
      
    case 1:
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (y < v1a) || (y > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      y = fmod( y - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (y+1) * gy[num] )) % gy[num] );
      return( getmap_num_sub(tx,ty,num) );
      
    case 2:
      z = atan2( z , sqrt(x*x+y*y) ) / PI*2;
      x = atan2( y , x ) / PI;
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (z < v1a) || (z > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      z = fmod( z - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (z+1) * gy[num] )) % gy[num] );
      return( getmap_num_sub(tx,ty,num) );
      
    case 3:
      z = sqrt( x*x+y*y );
      x = atan2( y , x ) / PI;
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (z < v1a) || (z > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      z = fmod( z - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (z+1) * gy[num] )) % gy[num] );
      return( getmap_num_sub(tx,ty,num) );
      
    case 4:
      x = atan2( y , x ) / PI;
      if ( (x < u1a) || (x > u2a) ) return(0);
      if ( (z < v1a) || (z > v2a) ) return(0);
      x = fmod( x - u1 , u2 - u1 ) / (u2 - u1);
      z = fmod( z - v1 , v2 - v1 ) / (v2 - v1);
      tx = (int)( ((int)( (x+1) * gx[num] )) % gx[num] );
      ty = (int)( ((int)( (z+1) * gy[num] )) % gy[num] );
      return( getmap_num_sub(tx,ty,num) );
      
      
    default :
      err("(getmap_num) T|[gĂȂ}bsO[hł");
      
  }

}


int getmap_num_sub( int tx, int ty, int num )
{
int v;

  switch (maptyp[num])
  {
    case 0:
      v = (int)( ((unsigned char *)(((int *)map)[num]))
        [(tx+ty*gx[num])/8] );
      v = (v >> (tx+ty*gx[num])%8) & 0x01;
      break;
    case 1:
      v = (int)( ((unsigned char *)(((int *)map)[num]))
        [(tx+ty*gx[num])/2 + sizeof (FRGB)*16] );
      if ( (tx+ty*gx[num])%2 == 0 )
      {
        v = v & 0x0f;
      }
      else
      {
        v = (v >> 4) & 0x0f;
      };
      break;
    case 2:
      v = (int)( ((unsigned char *)(((int *)map)[num]))
        [tx+ty*gx[num] + sizeof (FRGB)*256] );
      break;
    case 3:
      v = (int)( ((short int *)(((int *)map)[num]))[ tx+ty*gx[num] ] );
      break;
    case 4:
      v = (int)( ((unsigned char *)(((int *)map)[num]))[(tx+ty*gx[num])*3] );
      break;
    default:
      err("(getmap_col_sub) T|[gĂȂOtBbNf[^ł");
      exit(1);
  };
  return (v);
}



FV getmap_n(float x,float y,float z,  float nx,float ny,float nz  ,float b,MAP *map_temp,MATRIX mtx1,MATRIX mtx2)
{
FV p_tmp,p_tmp2,n_tmp,d,d2,d3;
MATRIX mtx_tmp1,mtx_tmp2;
FV pu,pv;
float a1,a2,a3,puf,pvf;
MAP *map_tmp;


  map_tmp = map_temp;
  
  p_tmp.x = x;
  p_tmp.y = y;
  p_tmp.z = z;
  
  n_tmp.x = nx;
  n_tmp.y = ny;
  n_tmp.z = nz;
  
  mtx_copy(mtx_tmp1,mtx1) ;
  mmul1( mtx_tmp1,(*map_tmp).mtx1 );
  
  mtx_copy(mtx_tmp2,mtx2) ;
  mmul2( (*map_tmp).mtx2,mtx_tmp2 );
  
  trans_it(&p_tmp,mtx_tmp1);
  trans_it2(&n_tmp,mtx_tmp1);
  
  
  
  d.x = d.y = d.z = 0;
  if ( map_tmp == NULL ) return(d);
  
  while ( map_tmp != NULL ) {
    
    
    switch( (*map_tmp).mapmode )
    {
      case 0:
        err("(getmap_n) ov}bsOɂ͑S}bsO͎g܂");
      case 1:
        pu.x = 1.0 ; pu.y = 0.0 ; pu.z = 0.0 ;
        pv.x = 0.0 ; pv.y = 1.0 ; pv.z = 0.0 ;
        
        puf = fabs((*map_tmp).u2 - (*map_tmp).u1) 
              / (float)(gx[(*map_tmp).mapnum]);
        pvf = fabs((*map_tmp).v2 - (*map_tmp).v1) 
              / (float)(gy[(*map_tmp).mapnum]);
        
        break;
      case 2:
        d3.x = d3.y = 0.0 ; d3.z = 1.0 ;
        pu = ptr_cross(p_tmp,d3);
        pv = ptr_cross(p_tmp,pu);
        if ( (a1=pu.x*pu.x+pu.y*pu.y+pu.z*pu.z) == 0 )
          pu.x = pu.y = pu.z = 0.0;
        else
        {
          a1 = sqrt(a1);
          pu.x = pu.x / a1;
          pu.y = pu.y / a1;
          pu.z = pu.z / a1;
        };
        if ( (a1=pv.x*pv.x+pv.y*pv.y+pv.z*pv.z) == 0 )
          pv.x = pv.y = pv.z = 0.0;
        else
        {
          a1 = sqrt(a1);
          pv.x = pv.x / a1;
          pv.y = pv.y / a1;
          pv.z = pv.z / a1;
        };
        
        a1 = sqrt(p_tmp.x*p_tmp.x + p_tmp.y*p_tmp.y);
        puf = fabs((*map_tmp).u2 - (*map_tmp).u1) 
              / (float)(gx[(*map_tmp).mapnum])
               * PI * a1;
        a1 = sqrt(p_tmp.x*p_tmp.x + p_tmp.y*p_tmp.y + p_tmp.z*p_tmp.z);
        pvf = fabs((*map_tmp).v2 - (*map_tmp).v1) 
              / (float)(gy[(*map_tmp).mapnum])
               * PI * a1;
        
        break;
      case 3:
        pv.x = p_tmp.x ; pv.y = p_tmp.y ; pv.z = 0 ;
        d2.x = d2.y = 0.0 ; d2.z = 1.0 ;
        pu = ptr_cross(d2,pv);
        if ( (a1=pu.x*pu.x+pu.y*pu.y+pu.z*pu.z) == 0 )
          pu.x = pu.y = pu.z = 0.0;
        else
        {
          a1 = sqrt(a1);
          pu.x = pu.x / a1;
          pu.y = pu.y / a1;
          pu.z = pu.z / a1;
        };
        if ( (a1=pv.x*pv.x+pv.y*pv.y+pv.z*pv.z) == 0 )
          pv.x = pv.y = pv.z = 0.0;
        else
        {
          a1 = sqrt(a1);
          pv.x = pv.x / a1;
          pv.y = pv.y / a1;
          pv.z = pv.z / a1;
        };
        
        a1 = sqrt(p_tmp.x*p_tmp.x + p_tmp.y*p_tmp.y);
        puf = fabs((*map_tmp).u2 - (*map_tmp).u1) 
              / (float)(gx[(*map_tmp).mapnum])
              * PI * a1;
        pvf = fabs((*map_tmp).v2 - (*map_tmp).v1) 
              / (float)(gy[(*map_tmp).mapnum]);
        
        break;
        
      case 4:
        d2.x = p_tmp.x ; d2.y = p_tmp.y ; d2.z = 0 ;
        pv.x = pv.y = 0.0 ; pv.z = 1.0 ;
        pu = ptr_cross(d2,pv);
        if ( (a1=pu.x*pu.x+pu.y*pu.y+pu.z*pu.z) == 0 )
          pu.x = pu.y = pu.z = 0.0;
        else
        {
          a1 = sqrt(a1);
          pu.x = pu.x / a1;
          pu.y = pu.y / a1;
          pu.z = pu.z / a1;
        };
        if ( (a1=pv.x*pv.x+pv.y*pv.y+pv.z*pv.z) == 0 )
          pv.x = pv.y = pv.z = 0.0;
        else
        {
          a1 = sqrt(a1);
          pv.x = pv.x / a1;
          pv.y = pv.y / a1;
          pv.z = pv.z / a1;
        };
        
        a1 = sqrt(p_tmp.x*p_tmp.x + p_tmp.y*p_tmp.y);
        puf = fabs((*map_tmp).u2 - (*map_tmp).u1) 
              / (float)(gx[(*map_tmp).mapnum])
               * PI * a1;
        pvf = fabs((*map_tmp).v2 - (*map_tmp).v1) 
              / (float)(gy[(*map_tmp).mapnum]);
        
        break;
        
    
    
    }
    
    
    p_tmp2 = p_tmp;
    trans_it(&p_tmp2,mtx_tmp2);
    a1 = 0;
    if ( getmap_mono(p_tmp2.x, p_tmp2.y, p_tmp2.z, nx, ny, nz, map_tmp, mtx1, &a1 ) == 0 ) a1 = b;
    a1 *= (*map_tmp).k;
    
    p_tmp2.x = p_tmp.x + pu.x*puf;
    p_tmp2.y = p_tmp.y + pu.y*puf;
    p_tmp2.z = p_tmp.z + pu.z*puf;
    trans_it(&p_tmp2,mtx_tmp2);
    a2 = 0;
    if ( getmap_mono(p_tmp2.x, p_tmp2.y, p_tmp2.z, nx, ny, nz, map_tmp, mtx1, &a2 ) == 0 ) a2 = b;
    a2 *= (*map_tmp).k;
    
    p_tmp2.x = p_tmp.x + pv.x*pvf;
    p_tmp2.y = p_tmp.y + pv.y*pvf;
    p_tmp2.z = p_tmp.z + pv.z*pvf;
    trans_it(&p_tmp2,mtx_tmp2);
    a3 = 0;
    if ( getmap_mono(p_tmp2.x, p_tmp2.y, p_tmp2.z, nx, ny, nz, map_tmp, mtx1, &a3 ) == 0 ) a3 = b;
    a3 *= (*map_tmp).k;
    
/*    sprintf(msg,"a:%lf,%lf%,%lf\n",a1,a2,a3);
    mes(msg);
    sprintf(msg,"puf:%lf,pvf:%lf\n",puf,pvf);
    mes(msg);
    sprintf(msg,"pu:%lf,%lf,%lf,pv:%lf,%lf,%lf\n",pu.x,pu.y,pu.z,pv.x,pv.y,pv.z);
    mes(msg);
    sprintf(msg,"n_tmp:%lf,%lf,%lf\n",n_tmp.x,n_tmp.y,n_tmp.z);
    mes(msg);*/
    
    
    
    
    d2 = ptr_cross(n_tmp,pv);
    d3 = ptr_cross(n_tmp,pu);
    d2.x = (a2-a1)/puf*d2.x - (a3-a1)/pvf*d3.x ;
    d2.y = (a2-a1)/puf*d2.y - (a3-a1)/pvf*d3.y ;
    d2.z = (a2-a1)/puf*d2.z - (a3-a1)/pvf*d3.z ;
    
    a1 = sqrt(n_tmp.x*n_tmp.x + n_tmp.y*n_tmp.y + n_tmp.z*n_tmp.z);
    d2.x = d2.x/a1;
    d2.y = d2.y/a1;
    d2.z = d2.z/a1;
    
    trans_it2(&d2,mtx_tmp2);
    
    d.x += d2.x;
    d.y += d2.y;
    d.z += d2.z;
    
    
    map_tmp = (MAP *)( (*map_tmp).next );
  }
  
/*  sprintf(msg,"%lf  ,%lf  ,%lf\n",d.x,d.y,d.z);
  mes(msg);*/
  
  
  return(d);
  
}


FV ptr_cross(FV a,FV b)
{
FV c;

    c.x = a.y*b.z - a.z*b.y ;
    c.y = a.z*b.x - a.x*b.z ;
    c.z = a.x*b.y - a.y*b.x ;
    
    return(c);
}

