/*
   recording routines
*/
#include <string.h>
#include "rt.h"


FILE *fp_rec;
int rec_type;
int rec_x,rec_y,rec_ofs;
char rec_buf[2048*3];


void record(int x,int y)
{
int i;
unsigned short int v;

unsigned int b,r,g ;


  plot( x,y, &pix ) ;
  
  
  b = pix.b * 256. ;
  r = pix.r * 256. ;
  g = pix.g * 256. ;
  
  b = (b > 255)? 255 : b & 0xff ;
  r = (r > 255)? 255 : r & 0xff ;
  g = (g > 255)? 255 : g & 0xff ;
  
  v = (g >> 3)*32*32 + (r >> 3)*32 + (b >> 3);
  
  for(i=x;i<x+dx;i++)
  {
    if (i<PIXW)
    {
      switch(rec_type)
      {
        case 0:
          ((unsigned short int *)(rec_buf))[i-sx] = v;
          break;
        case 1:
          ((unsigned char*)rec_buf)[(i-sx)*3  ] = r;
          ((unsigned char*)rec_buf)[(i-sx)*3+1] = g;
          ((unsigned char*)rec_buf)[(i-sx)*3+2] = b;
          break;
      }
    }
  }
  
}


void record_write(int y)
{
int ofs,i;
unsigned int size;
  for(i=y;i<y+dy;i++)
  {
    if(i<PIXH)
    {
      switch(rec_type)
      {
        case 0:
          ofs = rec_ofs + (sx + i*PIXW)*2;
          size = (ex - sx + 1) * 2;
          break;
        case 1:
          ofs = (sx + i*PIXW)*3;
          size = (ex - sx + 1) * 3;
          break;
      }
      fseek(fp_rec,ofs,0);
      fwrite(rec_buf,size,1,fp_rec);
    }
  }
  for(i=0;i<2048*3;i++) rec_buf[i]=0;
}



void record_open(char *filename)
{
int i,i1,i2,i3,x,y;
char fn[80],fn2[80],ext[4],*temp;
IFD_E ifd_tmp;

  rec_x = sx ;
  rec_y = sy ;
  for(i=0;i<2048*3;i++) rec_buf[i]=0;
  
  
  if (  (temp = strchr(filename,'.')) == NULL  ) 
    { 
      err("(record_open) OtBbN̊gq܂");
      exit(1);
    };
  temp++;
  strncpy(ext,temp,3);
  strncpy(fn,filename, strcspn(filename,".") );
  fn[strcspn(filename,".")]=0;
  
  if ( strcmp(ext,"tif")==0 || strcmp(ext,"TIF")==0 )
  {
/*    strcat(fn,".tif");*/
    rec_type = 0;
    if ( (fp_rec=fopen(filename,"rb"))!=NULL )
    {
      
      for (i=0; i<4; i++) getc(fp_rec);
      fread ( (char *)(&i1),4,1,fp_rec );
      
      fseek(fp_rec,i1,0);
      i2 = getc(fp_rec); i2 += getc(fp_rec)*256 ;
      
      for (i=0; i<i2; i++)
      {
        fread ( (char *)(&ifd_tmp),12,1,fp_rec ) ;
        
        switch ( ifd_tmp.tag )
        {
          case 0x100 :
            x = ifd_tmp.value;
            break;
          case 0x101 :
            y = ifd_tmp.value;
            break;
          case 0x102 :
            i3 = ifd_tmp.value;
            break;
          case 0x111 :
            rec_ofs = ifd_tmp.value ;
            break;
        };
      };
      
      if ( i3==16 && x==PIXW && y==PIXH )
      {
        fclose(fp_rec);
        if ( (fp_rec=fopen(filename,"r+b"))==NULL )
        {
          err("(record_open) .TIFt@Cɒǉł܂");
          exit(1);
        }
        fseek(fp_rec,rec_ofs,0);
        return;
      }
      fclose(fp_rec);
    }
    
    setTIFFmode( 2, PIXW, PIXH ) ;
    mkIFD() ;
    if( ( fp_rec = fopen( filename, "wb" )) == 0 )
    {
      err("(record_open) .TIFt@C܂");
      exit(1);
    }
    putIFD( fp_rec ) ;
    rec_ofs = tiff_iofs;
    fseek(fp_rec,rec_ofs,0);
    for (i=0 ;i<PIXW*PIXH*2 ;i++)
      if ( putc(0,fp_rec) == -1)
      {
        fclose(fp_rec);
        fclose( fopen(filename,"w") );
        err("(record_open) fBXNeʂ܂");
        exit(1);
      }
    fclose(fp_rec);
    if ( (fp_rec=fopen(filename,"r+b"))==NULL )
    {
      err("(record_open) .TIFt@C܂");
      exit(1);
    }
    fseek(fp_rec,rec_ofs,0);
    return;
  }
  else if ( strcmp(ext,"fal")==0 || strcmp(ext,"FAL")==0 )
  {
    rec_type = 1;
    
    strcpy(fn2,fn);
    strcat(fn2,".fal");
    strcat(fn,".rgb");
    if ( (fp_rec=fopen(fn2,"r"))!=NULL )
    {
      fscanf(fp_rec,"%*s%ld%ld",&x,&y);
      fclose(fp_rec);
      
      if ( x==PIXW && y==PIXH )
      {
        if ( (fp_rec=fopen(fn,"r+b"))==NULL )
        {
          err("(record_open) .RGBt@Cɒǉł܂");
          exit(1);
        }
        return;
      }
    }
    
    if ( (fp_rec=fopen(fn2,"w"))==NULL )
    {
      err("(record_open) .FALt@C܂");
      exit(1);
    }
    fprintf(fp_rec,"F_ALL(V1.00)\n");
    fprintf(fp_rec,"  %d   %d     0     0\n",PIXW,PIXH);
    fprintf(fp_rec,"   1.00   255   255   255   0");
    fclose(fp_rec);
    
    if ( (fp_rec=fopen(fn,"wb"))==NULL )
    {
      err("(record_open) .RGBt@C܂");
      exit(1);
    }
    fseek(fp_rec,0,0);
    for (i=0 ;i<PIXW*PIXH*3 ;i++)
      if ( putc(0,fp_rec) == -1)
      {
        fclose(fp_rec);
        fclose( fopen(fn,"w") );
        err("(record_open) fBXNeʂ܂");
        exit(1);
      }
  }


}


void record_close()
{

  fclose(fp_rec);

}




void plot(int x,int y,FRGB *c )
{
CRGB col ;
unsigned int b,r,g ;

  b = c->b * 256. ;
  r = c->r * 256. ;
  g = c->g * 256. ;

  col.cb = (b > 255)? 255 : b & 0xff ;
  col.cr = (r > 255)? 255 : r & 0xff ;
  col.cg = (g > 255)? 255 : g & 0xff ;

  boxfil((int)((float)x*xasp),(int)((float)y*yasp),(int)((float)(x+dx-1)*xasp),(int)((float)(y+dy-1)*yasp), &col ) ;  
}

