/*
     ray-reacing
*/

#define MAIN

#include "rt.h"
#include <string.h>

char output_filename[80];
int rmode ; /* record mode */
FRGB pix,rpix,lpix; /* pixel color data */
int sx,sy,ex,ey ; /* record renge */
int dx,dy ; /* pixel size */
int PIXW,PIXH; /* screen size */

float temp ;
FV lep,rep ; /* eye point right & left */
FV ev,lev,rev ; /* eye vector */
FV u,v ; /* eye surface vector */
float du,dv ; /* 1/2 eye surface size */

FRGB bpix,brpix,blpix ;/* for temp. */

float lpow ; /* light power */
int trnum ; /* number of trace */

float asp ; /* screen aspect */
float xasp,yasp ;
int maxtn ; /* max trace number */
float mintv ; /* min trace light */
float eps ; /* minimum number */
int anti; /* anti-aliasing flag */
float anti_level ;

FV ep,re,sre ; /* eye data */
float edeg,ew ; /* eye surface */

float half ; /* light decreace */
int mist ; /* mist flag */

FRGB sky, env ; /* sky and environment */
int raster ; /* current raster address */

int elnum ; /* number of light */
ELIT *el;/*[MAXEL] ;  eternal light */

int plnum ; /* number of point light */
PLIT *pl;/*[MAXPL] ;  point light */

int slnum ; /* number of spot light */
SLIT *sl;/*[MAXSL] ;  spot light */

int colornum ; /* number of color */
SHADE *color;/*[MAXCOL] ;  color */

int primnum ; /* number of primitives */
PRIM *pr;/*[MAXPRIM] ;  pr room is shared with stack */

int mapnum;
int maptyp[MAXMAP];
int gx[MAXMAP],gy[MAXMAP];
unsigned short int *map[MAXMAP];

FILE *fp_mes;

void main(int ac,char **av)
{
FILE *fp ;
int time ;
char path[32],msg[256] ;

  if( ac < 2 ) err( "(main) p|^ُł" ) ;
  
  mes_open( av[1] ) ;
  
  mes("") ;
  mes("                                                    ") ;
  mes("          EASTRAY ver 1.01                              ") ;
  mes("                             copyright EAST 1990    ") ;
  mes("") ;
  mes("") ;
  
  mes("f[^t@Cǂݍ݂܂B");
  getsrc( av[1] ) ;
  
  scrninit() ;
  
  time = clock() ;
  rtmain() ;
  time = (clock() - time)/ CLK_TCK ;
  
  mes("");
  mes("");
  sprintf( msg,"vZ : %ld seconds\n",time ) ;
  mes(msg);
  
  mes_close() ;
}

void err( char *msg )
{
  printf (        "******* G[܂Bu %s v\n",msg );
  fprintf( fp_mes,"******* G[܂Bu %s v\n",msg );
  exit(1);
}

void mes( char *msg )
{
  fprintf( fp_mes, "%s\n",msg );
  fflush( fp_mes );
}

void mes_open( char *path )
{
char *temp,fn[80];


  if (  (temp = strchr(path,'.')) == NULL  ) 
  { 
    strcpy(fn,path);
  }
  else
  {
    strcpy(fn,path);/*, strcspn(path,".") );*/
    fn[strcspn(path,".")]=0;
  }
  
  strcat(fn,".msg");
  
  
  
  
  if ( (fp_mes = fopen( fn,"wt" )) == NULL )
  {
    err("(mes_open) bZ[Wt@CI[vł܂");
    exit(1);
  }
}

void mes_close()
{
  if ( fclose(fp_mes) != 0 )
  {
    err("(mes_close) bZ[Wt@CN[Ył܂");
    exit(1);
  }
}

