/*
  header file for RT
*/

/* 386pɃRpCƂ͎̂QpragmaoffɂĂ */
#pragma on(Floating_point);
#pragma on(387);


#pragma on(Align_labels);


#include <time.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <snd.h>
#include "tiff.h"


#define PI 3.14159265
#define DEG 0.017453292
#define MAX 1e+30

#define DSP_PIXW 512
#define DSP_PIXH 480


#define float double

typedef struct {
  float x,y,z ;
} FV ;

typedef struct {
  int ix,iy,iz ;
} IV ;

typedef struct {
  float x,y ;
} FV2 ;

typedef struct {
  float b,r,g ;
} FRGB ;

typedef struct {
  char cb,cr,cg ;
} CRGB ;

typedef double MATRIX[4][4];

typedef struct MAP{
  void *next ;
  int mapnum ;
  float k ;
  int mapmode ;
  float u1,v1,u2,v2,u1a,v1a,u2a,v2a ;
  MATRIX mtx1,mtx2 ;
} MAP;

typedef struct {
  FRGB pc ;
  void *cmap ;
  int styp ;
  void *spara ;
  FRGB ref ;
  void *rmap ;
  FRGB refr ;
  void *rrmap ;
  float n ;
  void *nmap ;
  float half ;
  void *hmap ;
  float b ;
  void *bmap ;
} SHADE ;

typedef struct {
  float high,k ;
  void *hmap,*kmap ;
} SPECK1 ;

typedef struct {
  FRGB ref ;
  float n,f ;
  void *rmap,*nmap,*fmap ;
} SPECK2 ;

typedef struct {
  FRGB ref ;
  float px,py,pz,vx,vy,vz,a,b,c ;
  void *rmap,*amap,*bmap,*cmap ;
} SPECK3 ;

typedef struct {
  FRGB ref ;
  float vx,vy,vz,a,b,c ;
  void *rmap,*amap,*bmap,*cmap ;
} SPECK4 ;



typedef struct {
  int link ;
  int sgn ;
  int sh ;
  void *shmap ;
  char ptyp ;
  float a[10] ;
  MATRIX mtx1,mtx2 ;  /*   WORLD => (mtx1) => ORIGINAL => (mtx2) => WORLD   */
} PRIM ;


typedef struct {
  FV elt ;
  FRGB elc ;
  float els ;
  float elk ;
} ELIT ;

typedef struct {
  FV plt ;
  FRGB plc ;
  float plk ;
} PLIT ;

typedef struct {
  FV slt ;
  FV sld ;
  FRGB slc ;
  float sls ;
  float slk ;
} SLIT ;

#define MAXEL 20
#define MAXPL 20
#define MAXSL 20
#define MAXCOL 256
#define MAXPRIM 1024
#define MAXMAP 32

#define fsign(x) ((x)>0?1:-1)
#define sq(x) ((x)*(x))

#ifndef MAIN


extern char output_filename[80];
extern int rmode ; /* record mode */
extern FRGB pix,rpix,lpix; /* pixel color data */
extern int sx,sy,ex,ey ; /* record renge */
extern int dx,dy ; /* pixel size */
extern int PIXW,PIXH; /* screen size */
extern float anti_level;

extern float temp ;
extern FV lep,rep ; /* eye point right & left */
extern FV ev,lev,rev ; /* eye vector */
extern FV u,v ; /* eye surface vector */
extern float du,dv ; /* 1/2 eye surface size */

extern FRGB bpix,brpix,blpix ;/* for temp. */

extern float lpow ; /* light power */
extern int trnum ; /* number of trace */

extern float asp ; /* screen aspect */
extern float xasp,yasp ;
extern int maxtn ; /* max trace number */
extern float mintv ; /* min trace light */
extern float eps ; /* minimum number */
extern int anti; /* anti-aliasing flag */

extern FV ep,re,sre ; /* eye data */
extern float edeg,ew ; /* eye surface */

extern float half ; /* light decreace */
extern int mist ; /* mist flag */

extern FRGB sky, env ; /* sky and environment */
extern int raster ; /* current raster address */

extern int elnum ; /* number of eternal light */
extern ELIT *el;/*[MAXEL] ;  eternal light */

extern int plnum ; /* number of point light */
extern PLIT *pl;/*[MAXPL] ;  point light */

extern int slnum ; /* number of spot light */
extern SLIT *sl;/*[MAXSL] ;  spot light */

extern int colornum ;
extern SHADE *color;/*[MAXCOL] ;*/

extern int primnum ; /* number of primitives */
extern PRIM *pr;/*[MAXPRIM] ;   pr room is shared with stack */

extern int mapnum ; /* number of mapping data */
extern int *maptyp;/*[MAXMAP] ;  type of mapping data
                               0 : tiff 2
                               1 : tiff 16
                               2 : tiff 256
                               3 : tiff 32k
                               4 : rgb 24bit color */
extern int *gx,*gy;/*[MAXMAP] ;  size of mapping data */
extern void **map;/*[MAXMAP] ;  pointer for mapping data */

#endif


/*void joy_in_1(int port,int *status);*/



void err(char*);
void mes(char*);
void mes_open(char*);
void mes_close();
int  svram(FILE *,char*,int,int,int,int,int,int);
int  ldram(FILE *,char*,int,int,int,int,int,int);
void screen(char*,int,int);
void scrninit(void);
void boxfil(int,int,int,int,CRGB*);
void record(int,int);
void record_write(int);
void record_open(char*);
void record_close();
void plot(int,int,FRGB*);
void rtmain(void);
FRGB trace_4pix(float,float,float,float,FRGB,FRGB,FRGB,FRGB,int,float);
FRGB trace_xy(float,float);
void trace(FV*,FV*,FRGB*,FRGB,float,int,FRGB);
int  shadow_el(FV*,FV*,FV,float,FRGB*);
int  shadow_pl(FV*,FV*,FV,float,FRGB*,FV);

void shading(float ,float ,float ,PRIM *,FV ,FV ,FV ,FV *,FRGB ,FRGB ,float ,float ,SHADE *,MATRIX ,FV *, FRGB *, FRGB, FRGB );




int  getmap_col(float,float,float,float,float,float,MAP*,MATRIX mtx,float*,float*,float*);
FRGB getmap_col_sub( int , int , int  );

int  getmap_mono(float,float,float,float,float,float,MAP*,MATRIX mtx,float*);

int getmap_num(float ,float ,float ,  float ,float ,float ,  MAP *,MATRIX );
int getmap_num_sub( int , int , int  );

FV getmap_n(float ,float ,float ,  float ,float ,float   ,float ,MAP *,MATRIX ,MATRIX );
FV ptr_cross(FV ,FV );

void loadmap(int,char*);

int  cross(FV*,FV*,float*,int);
void cross_or(int*,int*,FV*,FV*,float*,int);
void cross_and(int*,int*,FV*,FV*,float*,int);
void cross_range(int*,int*,FV*,FV*,float*,int);

void getsrc(char*);
void macros(FILE*,float*,int);

int  inout(FV*,int);
int  inout_check(int ,int );
int  inout_or(FV*,int,int*);
int  inout_and(FV*,int,int*);
int  inout_range(FV*,int,int*);


int  skip(FILE*);
void mtx_copy(MATRIX,MATRIX);
void unit(MATRIX);
void trans_it(FV*,MATRIX);
void trans_it2(FV*,MATRIX);
void mmul1(MATRIX,MATRIX);
void mmul2(MATRIX,MATRIX);
void rotx(MATRIX,float);
void roty(MATRIX,float);
void rotz(MATRIX,float);
void movx(MATRIX,float);
void movy(MATRIX,float);
void movz(MATRIX,float);
void scalx(MATRIX,float);
void scaly(MATRIX,float);
void scalz(MATRIX,float);
void get_trans(FILE *,MATRIX,MATRIX);

void or_levels(FILE *,int *,MATRIX,MATRIX);
void and_levels(FILE *,int *,MATRIX,MATRIX);
void range_levels(FILE *,int *,MATRIX,MATRIX);
void get_prim(FILE *,int *i,MATRIX,MATRIX);
void get_map(FILE *,void **);




/*
IFD_E *allocIFD( int ); 
void _freeIFD( IFD_E * );
void freeIFD( void );
*/

void storeIFD( IFD_E *,short ,short ,long ,long );
int mkIFD(void);
int putIFD( FILE * );
void setTIFFmode( int ,int ,int );

/*
int getIFD( FILE * );
*/



