
#include <stdio.h>
#include <stdlib.h>

#define TIFF 
#include "tiff.h"

short tiff_IFDsize = 15 ;
long tiff_width = 640 ;
long tiff_length = 480 ;
long tiff_bpp = 4 ;
long tiff_fill = 2 ;
long tiff_maxv = 0xF ;
long tiff_iofs = 0 ;
long tiff_xrofs = 0 ;
long tiff_yrofs = 0 ;
int tiff_err = 0 ;

struct {
	long x_c ;
	long x_m ;
	long y_c ;
	long y_m ;
} tiff_resolution  = { 75,1,75,1 } ;

IFD_E ifd[15] ;
/*
IFD_E *allocIFD( int count ) 
{
	return( (IFD_E *)malloc( sizeof(IFD_E)*count ) ) ;
}

void _freeIFD( IFD_E *ptr )
{
	free( ptr ) ;
}

void freeIFD( void )
{
	free( ifd ) ;
}
*/
void storeIFD( IFD_E *p,short tag,short type,long size,long value)
{
	p->tag = tag ;
	p->type = type ;
	p->count = size ;
	p->value = value ;
}

/* make defalut format of IFD */
int mkIFD(void)
{
	int c = 0 ;

	IFD_E *ifdp ;
/*	if( (ifd = allocIFD(15)) == 0 ) 
		{ tiff_err = TIF_ERR_MEM ;return -1 ; }*/
	ifdp = ifd ;
	tiff_xrofs = 8 + 2 + tiff_IFDsize * sizeof(IFD_E) + 4 ;
	tiff_yrofs = tiff_xrofs + 8 ;
	tiff_iofs = 0x200 ;
	storeIFD(ifdp++,GeneralDescription,ShortType,1,1) ;
	storeIFD(ifdp++,ImageWidth,ShortType,1,tiff_width) ;
	storeIFD(ifdp++,ImageLength,ShortType,1,tiff_length) ;
	storeIFD(ifdp++,BitsPerSample,ShortType,1,tiff_bpp) ;
	storeIFD(ifdp++,Compression,ShortType,1,1) ;
	storeIFD(ifdp++,PhotometricInterpretation,ShortType,1,1) ;
	storeIFD(ifdp++,FillOrder,ShortType,1,tiff_fill) ;
	storeIFD(ifdp++,StripOffset,LongType,1,tiff_iofs) ;
	storeIFD(ifdp++,Orientation,ShortType,1,1) ;
	storeIFD(ifdp++,SamplesPerPixel,ShortType,1,1) ;
	storeIFD(ifdp++,MinSampleValue,ShortType,1,0 ) ;
	storeIFD(ifdp++,MaxSampleValue,ShortType,1,tiff_maxv ) ;
	storeIFD(ifdp++,XResolution,RationalType,1,tiff_xrofs) ;
	storeIFD(ifdp++,YResolution,RationalType,1,tiff_yrofs) ;
	storeIFD(ifdp  ,PlanarConfigration,ShortType,1,1) ;
	return(0) ;
}

int putIFD( FILE *fp ) 
{
	long idv,ifdofs,term ;
	idv = ID_VERSION ;
	ifdofs = sizeof(idv) + sizeof(ifdofs) ;

	term = 0 ;

	if( fwrite(&idv,sizeof(idv),1,fp ) == 0 ) return -1 ;
	if( fwrite(&ifdofs,sizeof(ifdofs),1,fp) == 0 ) return -1 ;
	if( fwrite(&tiff_IFDsize,sizeof(tiff_IFDsize),1,fp) == 0 ) return -1;
	if( fwrite(ifd,sizeof(IFD_E),tiff_IFDsize,fp) == 0 ) return -1 ;
	if( fwrite(&term,sizeof(term),1,fp) == 0 ) return -1 ;
	if( fwrite(&tiff_resolution,sizeof(tiff_resolution),1,fp) == 0) return -1 ;
	fseek(fp, tiff_iofs, SEEK_SET ) ;
/*	freeIFD();*/
	return 0 ;
}

void setTIFFmode( int mode ,int x ,int y )
{
	switch( mode ) {
	case TIFF_16:
		tiff_width = x ;
		tiff_length = y ;
		tiff_bpp = 4 ;
		tiff_fill = 2 ;
		tiff_maxv = 0xF ;
		break ;
	case TIFF_32K:
		tiff_width = x ;
		tiff_length = y ;
		tiff_bpp = 16 ;
		tiff_fill = 1 ;
		tiff_maxv = 0x7FFF ;
		break ;
	case TIFF_256:
		tiff_width = x ;
		tiff_length = y ;
		tiff_bpp = 8 ;
		tiff_fill = 1 ;
		tiff_maxv = 0xFF ;
		break ;
	}
}


/* tiff head load */
/*
int getIFD( FILE *fp )
{
	IFD_E *ifdp ;
	long idv,ifdofs ;
	int i ;
	
	if( fread( &idv, 4, 1, fp ) == 0 ) 
		{ tiff_err = TIF_ERR_FR ; return -1 ;}
	if( idv != ID_VERSION ) { tiff_err = TIF_ERR_ID ; return -1 ;}
#ifdef DEBUG
printf( "get header\n" ) ;
#endif
	if( fread( &ifdofs, 4, 1, fp) == 0 )
		{ tiff_err = TIF_ERR_FR ; return -1 ;}
	fseek(fp, ifdofs, SEEK_SET ) ;
#ifdef DEBUG
printf( "seek to IFD header \n" ) ;
#endif
	if( fread( &tiff_IFDsize, 2, 1, fp) == 0  )
		{ tiff_err = TIF_ERR_FR ; return -1 ;}
#ifdef DEBUG
printf( "number of tags = %d \n",tiff_IFDsize ) ;
#endif
	if(( ifd = allocIFD( tiff_IFDsize ) ) == 0 )
		{ tiff_err = TIF_ERR_MEM ; return -1 ;}
	ifdp = ifd ;
	for( i = 0 ; i < tiff_IFDsize ; i++ ) {
		if( fread( ifdp++, sizeof(IFD_E),1, fp ) == 0 )
			{ tiff_err = TIF_ERR_FR ; return -1; } 
#ifdef DEBUG
printf( "get tag #%d\n",(ifdp-1)->tag ) ;
#endif 
	}
	ifdp = ifd ;
	for( i = 0 ; i < tiff_IFDsize ; i++ ) {
		switch( ifdp->tag ) {
		case ImageWidth:
			tiff_width = ifdp->value ;
			break ;
		case ImageLength:
			tiff_length = ifdp->value ;
			break ;
		case BitsPerSample:
			tiff_bpp = ifdp->value ;
			break ;
		case StripOffset:
			tiff_iofs = ifdp->value ;
			break ;
		default: ;
		}
		ifdp++ ;
	}
	return 0 ;		
}
*/
